package puissance4;

import jeuplateau.Joueur;
import jeuplateau.Plateau;

/**
 *
 * @author franck
 */
public class Evaluation {
    // Evaluation de la position pour le joueur _joueur
    // Retourne le ( score _joueur - score adversaire )
    public static int eval(Plateau _plateau , Joueur _joueur) {
        GrillePuissance4 grille = (GrillePuissance4) _plateau;
        int score = 0, scoreCase;

        if (_plateau.partieNulle())
            return 0;

        for (int c = 0; c < grille.getNbColonnes(); c++) {
            for (int l = 0; l < grille.getNbLignes(); l++) {
                if (grille.getPiece(c, l) != null) {
                    scoreCase = scoreCase(grille, c, l);
                    if (grille.getPiece(c, l).getJoueur() == _joueur)
                        score += scoreCase;
                    else
                        score -= scoreCase;
                }
            }
        }
        return score;
    }

    public static int scoreCase(GrillePuissance4 _grille, int _x, int _y) {
        int[][][] dir = { { { 1, 0 }, { 1, 1 }, { 0, 1 }, { 1, -1 } }, // vers la droite
                { { -1, 0 }, { -1, -1 }, { 0, -1 }, { -1, 1 } } // vers la gauche
        };

        Joueur joueurCase = _grille.getPiece(_x, _y).getJoueur();

        int x, y, scoreSens, scoreTotal = 0, distance = 1;

        // Dans les 4 directions
        for (int d = 0; d < 4; d++) {
            // Boucle sur les 2 sens.
            for (int s = 0; s < 2; s++) {
                scoreSens = 1;
                distance = 1;

                x = _x + dir[s][d][0];
                y = _y + dir[s][d][1];
                while (x < _grille.getNbColonnes() && x >= 0 && y < _grille.getNbLignes() && y >= 0 && distance <= 3) {
                    if (_grille.getPiece(x, y) != null && _grille.getPiece(x, y).getJoueur() != joueurCase) {
                        scoreSens = 0;
                        break;
                    }
                    if (_grille.getPiece(x, y) != null && _grille.getPiece(x, y).getJoueur() == joueurCase)
                        scoreSens++;

                    distance++;

                    x += dir[s][d][0];
                    y += dir[s][d][1];
                }
                if (scoreSens == 4)
                    scoreTotal += 10000;
                else if (distance > 3)
                    scoreTotal += scoreSens;

            }
        }
        return scoreTotal;
    }
}
